
// ----- id amelioration : gerer les limites par une methode et la sensibilite

#include "MyPotNum.h"

/* --- Ce ponteur est indispenssable pour permettre a l'IT (fonction statique de la classse)      */
/*     de communiquer avec les variables publiques et privees de la classe.                       */
MyPotNum * MyPotNum::ptc = NULL;   /* obligatoire : definie la reference vers MyObj::ptc  init?   */


MyPotNum::MyPotNum(int a)
{
  
  MyPotNum::ptc = this;  // init pointeur sur  contexte objet
  
  pinMode(interruptPinPhaseA, INPUT_PULLUP);
  pinMode(PinPhaseB, INPUT_PULLUP);
 
  #ifndef USE_BP_A7 // Modif V1.02
  pinMode(PinBP, INPUT_PULLUP);
  #endif
  
  flagUpDown=0;
  countUP=0;
  waitRisingPhase=0;
  
  sensitive=a;
  
  attachInterrupt(INTR, MyPotNum::IT_PotNum,FALLING); // 0 : int0 front descendant
  
}


/*-------------------------------------------------------------------------*/
/* Traitement du Comptage du potentiometre numerique (passe par adresse)   */
/*     (En liaison avec IT potentiometre)                                  */
/*  retour TRUE si un traitement execute (inc ou dec du compteur)          */
/*-------------------------------------------------------------------------*/
boolean MyPotNum::GereComptage(  MY_POT *monPot)
{ 
  if (flagUpDown)                            // changement d'etat du codeur? 
  { 
     if (monPot->Sensible<0)                // V1.03 ajout de sesibilité en entrée + et -
     {
          if (countUP)
          {
            if(--monPot->Compte < monPot->Sensible)
            {
               (monPot->Compteur)++;
               monPot->Compte=0; 
            } 
          }else{
            if(++monPot->Compte>=0)
            {
               (monPot->Compteur)--;
               monPot->Compte=monPot->Sensible; 
            } 
          }
     
     }else if (monPot->Sensible>0){                // V1.03 ajout de sesibilité en entrée + et -
     
       if (countUP) (monPot->Compteur)+=monPot->Sensible; else (monPot->Compteur)-=monPot->Sensible;
     }else{
       if (countUP) (monPot->Compteur)++; else (monPot->Compteur)--;
     }
     
       
    /*--------- gestion des limites -----*/
    if (monPot->Mode==P_BUTE)
    {
      if (monPot->Compteur>monPot->Maxi)monPot->Compteur=monPot->Maxi;
      else if (monPot->Compteur<monPot->Mini)monPot->Compteur=monPot->Mini;
    }
    else if (monPot->Mode==P_WRAPP)
    {
       if (monPot->Compteur>monPot->Maxi)monPot->Compteur=monPot->Mini;
       else if (monPot->Compteur<monPot->Mini)monPot->Compteur=monPot->Maxi;
    }

     flagUpDown=0;
     return true;
  } 
  return false;
}


/*-------------------------------------------------------------------------*/
/* Retourne l'etat du BP                                                   */
/*-------------------------------------------------------------------------*/
boolean MyPotNum::BpPushed(void)
{
  #ifdef USE_BP_A7    // Modif V1.02  
  
  if (debug=analogRead(PinBP) > 812) // 1024/2
      return false;
  else 
      return true;
  
 #else 
    return !digitalRead(PinBP);
 #endif
}


/*-------------------------------------------------------------------------*/
/* Retourne l'etat du du sens de rotation                                  */
/*-------------------------------------------------------------------------*/
boolean MyPotNum::Up(void)
{
  return (boolean)countUP;
}



/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
/* Traite interruption du potentiometre incremental sur ce principe :      */
/*    1ere etape : Phase A declenche IT sur front descendant               */
/*       - determine en fontion de la phase B le sens UP ou DWN            */
/*       - reprogramme IT sur detection front montant.                     */
/*    2eme etape :  sur IT confirmation                                    */
/*       - confirmation en fontion de la phase B du sens UP ou DWN         */
/*       - monte un flag pour traitement dans tache de fond. (ou IT timer) */
/*       - reprogramme IT sur detection front descendant.                  */
/*                                                                         */
/* QQ chose a traiter par tache de fond si "flagUpDown = 1"                */
/*    dans ce cas "countUP"= 1 ou 0 en foction du sens                     */
/*    Puis la tache de fond acquite (flagUpDown=0)                         */
/*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*/
void MyPotNum::IT_PotNum(void)
{
  static char MemCountUP=0;
  
 //MyPotNum::ptc->flagUpDown=MemCountUP; //debug
  
  if (MyPotNum::ptc->flagUpDown==0)  // : si pret pour un nouveau
  {
    if (MyPotNum::ptc->waitRisingPhase==0)   // falling phase?
    {
        if (digitalRead(PinPhaseB))
       
            MemCountUP = 1;
        else
            MemCountUP = 0;
            
        MyPotNum::ptc->waitRisingPhase=1;
        
        attachInterrupt(INTR,MyPotNum::IT_PotNum,RISING); // prochaine interruption front montant
    }
    else                                     // Rising phase 2eme etape confirmation
    {                   
      // 1er cas possibles attente UP:
      if (MemCountUP==1)                     // On a detecte un up :
      {
        if (!digitalRead(PinPhaseB))        // on attend une confirmation par le complement
        {
            MyPotNum::ptc->countUP = 1;                    // OK valide UP      
            MyPotNum::ptc->flagUpDown=1;
        }  
      } 
      
      // 2 cas possible attente Down:
      else    
      {
        if (digitalRead(PinPhaseB))        // on attend une confirmation par le complement
        {
            MyPotNum::ptc->countUP = 0;                   // OK valide Down    
            MyPotNum::ptc->flagUpDown=1;
        }  
      }     
      
      MyPotNum::ptc->waitRisingPhase=0;
      attachInterrupt(INTR,MyPotNum::IT_PotNum,FALLING); // retour  front descendant.
    }  
  }   
}
